/*#######################################################################################
Schlafzimmersteuerung 
#######################################################################################*/

#ifndef _SCHLAFZI_H
 #define _SCHLAFZI_H

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <inttypes.h>
#include <avr/eeprom.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/wdt.h>
#include <util/delay.h>

#include "uhr.h"

#define F_CPU       8000000UL  // 8 MHz
#define BAUD		9600UL
#define UBRR_BAUD	((F_CPU/(16*BAUD))-1)
#define USART_BUFFER_SIZE 8

//B3	4	E	Eingang Taster Schlafzimmer rechts
#define E_Taster_Schlafzi_rechts (PINB & _BV(3))
//B4	5	E	Eingang Taster Schlafzimmer links
#define E_Taster_Schlafzi_links (PINB & _BV(4))
//B5	6	E	Eingang Taster Gang Schranktre
#define E_Taster_Gang_Schrank (PIND & _BV(7))

//A1	39	Ausgang Relais Gang Schrankleuchte
#define R_A1_Gang_Schrankleuchte _BV(PA1)
//C0	22	Ausgang Relais Schlafzimmer Wandleuchten
#define R_C0_Schlafzi_Wandleuchte _BV(PC0)
//C1	23	Ausgang Relais Schlafzimmer Schrankleuchten
#define R_C1_Schlafzi_Schrankleuchte _BV(PC1)
//C2	24	Ausgang Relais Radiowecker (Tuner)
#define R_C2_Schlafzi_Radiowecker _BV(PC2)
//C6	28	Ausgang Relais Schlafzimmer Deckenleuchte
#define R_C6_Schlafzi_Deckenleuchte _BV(PC6)
//C7	29	Ausgang Relais Fernseher Schlafzimmer
#define R_C7_Schlafzi_Fernseher _BV(PC7)

void delay_ms(unsigned long millisekunden);

#define EEPROM_SECTION  __attribute__ ((section (".eeprom")))

#endif //_SCHLAFZI_H





