#include "schlafzi.h"
#include "uhr.h"

#define DEBOUNCE	256L		// debounce clock (256Hz = 4msec)

uint8_t prescaler;
uint16_t volatile mess_taste_rechts;
uint16_t volatile mess_taste_links;
uint16_t volatile mess_taste_beide;
uint8_t volatile sekunden;
uint8_t volatile minuten;
uint8_t volatile stunden;

// Licht Brennzeit
int volatile Gang_Schrankleuchte_Laufzeit_min;
int volatile Schlafzi_Schrankleuchte_Laufzeit_min;
int volatile Schlafzi_Radiowecker_Laufzeit_min;
int volatile Schlafzi_Deckenleuchte_Laufzeit_min;
int volatile Schlafzi_Wandleuchte_Laufzeit_min;
int volatile Schlafzi_Fernseher_Laufzeit_min;

SIGNAL (SIG_OUTPUT_COMPARE1A)
{
  unsigned char tcnt1h = TCNT1H;
  
  // Wird alle 4ms aufgerufen
  mess_taste_links++;
  mess_taste_rechts++;
  mess_taste_beide++;
  
  if (mess_taste_links >= 2000)
    mess_taste_links=0;
  if (mess_taste_rechts >= 2000)
    mess_taste_rechts=0;
  if (mess_taste_beide >= 2000)
    mess_taste_beide=0;
    
  OCR1A += F_CPU / DEBOUNCE -1;		// new compare value
  
  if( ++prescaler == (unsigned char)DEBOUNCE )
    {
      prescaler = 0;
      sekunden++;				// exact one second over
      
      #if F_CPU % DEBOUNCE			// handle remainder
        OCR1A += F_CPU % DEBOUNCE; 		// compare once per second
      #endif
      
      // Wenn Sekunde 60 erreicht hat Minute erhhen
      if(sekunden==60)
        {   
          sekunden=0;
		  minuten++;
          
          if (Gang_Schrankleuchte_Laufzeit_min > 0)
            Gang_Schrankleuchte_Laufzeit_min--;
          if (Schlafzi_Schrankleuchte_Laufzeit_min > 0)
		    Schlafzi_Schrankleuchte_Laufzeit_min--;
          if (Schlafzi_Radiowecker_Laufzeit_min > 0)
		    Schlafzi_Radiowecker_Laufzeit_min--;
          if (Schlafzi_Deckenleuchte_Laufzeit_min > 0)
		    Schlafzi_Deckenleuchte_Laufzeit_min--;
          if (Schlafzi_Wandleuchte_Laufzeit_min > 0)
		    Schlafzi_Wandleuchte_Laufzeit_min--;
          if (Schlafzi_Fernseher_Laufzeit_min > 0)
		    Schlafzi_Fernseher_Laufzeit_min--;
        }        
	  // Wenn Minute 60 erreicht hat Stunde erhhen
      if(minuten==60)
        {            
          minuten=0;
		  stunden++;
        }
	  // Wenn Stunden 24 erreicht hat Wochentag erhhen
      if(stunden==24)
        {            
          stunden=0;        
          
		  // 0=Montag
		  wtag++;
          if (wtag > 6)
            wtag=0;    
        }
    }
  TCNT1H = tcnt1h;			// restore for delay() !
}


void init_timer_uhr( void )
{
  TCCR1B = 1<<CS10;			// divide by 1
  OCR1A = 0;
  TCNT1 = -1;
  prescaler = 0;

  TIMSK = 1<<OCIE1A;
}
